'=========================================
' Count-email.vbs counts the lines in the specified text file 
' and sends as email if the number is greater than a specified number
'=========================================


Option Explicit	
	
Const ForWriting = 2	
Const ForReading = 1	
Const ForAppending = 8	

'=========================================
'Check if processes.txt file exists in specified directory
	
Dim objFSO 'File System Object	
Dim strFileContents 'Contents of processes.txt	
Dim intLength 'Length of contents	
Dim strEndofString ' Last line in file	
Dim objProcessesFile 'Path to processes.txt file		
	
' =====Configuration Area================	
objProcessesFile = "\\ozark\it$\processes\processes.txt"	
' =====End Configuration Area============	
	
Set objFSO = CreateObject("Scripting.FileSystemObject")	
	
If objFSO.FileExists(objProcessesFile) Then
	
'do nothing	
	
Else	
	Wscript.Echo "Error - Processes file missing."
	WScript.Quit
End If 	

'=========================================	
'Count the lines in the file processes.txt	

Set objProcessesFile = objFSO.OpenTextFile(objProcessesFile, ForReading)	
objProcessesFile.ReadAll	

'=========================================
' If the count > licenses owned then email alert
	
Dim objLicensesOwned 'The number of application licenses owned	
	
' =====Configuration Area================	
objLicensesOwned = 1	
' =====End Configuration Area============	
	
' WScript.Echo objProcessesFile.line & " " & "objects still counted"	
If objProcessesFile.line > objLicensesOwned then	
	
' =====Configuration Area================	
Const strSMTPServer = "smtp.alpineskihouse.com"	
Const strFrom       = "alerts@alpineskihouse.com"	
Const strTo         = "techsupport@alpineskihouse.com"	
' =====End Configuration Area============		
	
Dim objMail               ' the CDO object	
Dim objWSHNetwork         ' windows-script-host network object	
Dim strNetBIOSComputer    ' the netbios name of our computer	
	
'=========================================
' get the NetBIOS computer name	
	
Set objWSHNetwork  = CreateObject ("WScript.Network")	
strNetBIOSComputer = objWSHNetwork.ComputerName	
Set objWSHNetwork  = Nothing 	
	
'=========================================
' do the real work to send the message 	
	
Set objMail = CreateObject ("CDO.Message")	
objMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing")      = 2	
objMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver")     = strSMTPServer	
objMail.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = 25	
objMail.Configuration.Fields.Update	
objMail.From     = strFrom	
objMail.To       = strTo	
objMail.Subject = "Licensing Check!! " & Now	
objMail.Textbody = "Licensing Check!! "  & " The application count in use is " & objprocessesFile.line & " which is higher than number of licenses purchased " & Now	
objMail.Send	
Set objMail = Nothing	
                End if	
	
'=========================================
' Create or append data to log file	
					
Dim strProcLogDir ' Path to Reports folder	
Dim strProcLogFile ' Log file	
Dim objApp 'Specified application
Dim objProcLogFolder 'Processes Log Folder
Dim objProcLogFile 'Processes Log File	
Dim strProcLogText ' Text to write to Processes Log File
	
' =====Configuration Area================	
objApp = "excel.exe"	
strProcLogDir = "\\ozark\it$\reports"	
strProcLogFile = "\processcountlog.txt"	a
' =====End Configuration Area============	
	
	Sub subAppend
	
	' Append count to the log file processcountlog.txt
	
	Set objProcLogFile = objFSO.OpenTextFile(strProcLogDir & strProcLogFile, ForAppending, true)		
	strProcLogText = NOW & " | The # of instances of " & objApp & " running is " & objProcessesFile.Line
	' Writes strText to processcountlog.txt
        objProcLogFile.WriteLine(strProcLogText)	
	objProcLogFile.close
	End Sub

'=========================================	
' Check that the directory folder exists, if not create file

If objFSO.FolderExists(strProcLogDir) Then	
'do nothing

Else	
   Set objProcLogFolder = objFSO.CreateFolder(strProcLogDir)	
objProcLogFolder.close
End If	

'=========================================
' If log file exists append data, if not, then create file and append data
	
If objFSO.FileExists(strProcLogDir & strProcLogFile) Then	
   call subAppend	
Else	
   Set objProcLogFile = objFSO.CreateTextFile(strProcLogDir & strProcLogFile)		
objProcLogFile.Close	
   call subAppend	
End If 	
	
WScript.Quit	
